import { PropType } from 'vue';
import { ButtonVariant } from './Button.vue';
export type NotificationType = 'info' | 'success' | 'warning' | 'danger';
export interface Notification {
    message: string;
    type?: NotificationType;
    persistent?: boolean;
}
export interface NotificationAction {
    name: string;
    title?: string;
    disabled?: boolean;
    separator?: boolean;
    emit?: string;
    handler?: (action: NotificationAction) => void;
}
export declare function isNotificationAction(action: NotificationAction | '-'): action is NotificationAction;
declare const _default: import("vue").DefineComponent<{
    ouiaId: {
        type: StringConstructor;
        default: string | null;
    };
    ouiaSafe: BooleanConstructor;
    action: PropType<NotificationAction & {
        button: ButtonVariant | true;
    }>;
    actions: PropType<(NotificationAction | "-")[]>;
    delay: {
        type: NumberConstructor;
        default: number;
    };
    type: {
        type: PropType<NotificationType>;
        default: string;
    };
    toast: {
        type: BooleanConstructor;
        default: boolean;
    };
    persistent: {
        type: BooleanConstructor;
        default: boolean;
    };
}, {
    ouiaProps: import("vue").ComputedRef<{
        'data-ouia-component-type': string;
        'data-ouia-safe': boolean | undefined;
        'data-ouia-component-id': string;
    }>;
}, {
    $timeout: number | null;
}, {
    showDropdown(): number | false | undefined;
    alertClass(): string;
    buttonVariant(): ButtonVariant;
    typeIcon(): "pficon-info" | "pficon-ok" | "pficon-error-circle-o" | "pficon-warning-triangle-o";
}, {
    updateTimeout(): void;
    isAction: typeof isNotificationAction;
    dismiss(): void;
    triggered(action: NotificationAction): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    dismiss: (event: unknown) => boolean;
    action: (action: NotificationAction) => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    ouiaId: {
        type: StringConstructor;
        default: string | null;
    };
    ouiaSafe: BooleanConstructor;
    action: PropType<NotificationAction & {
        button: ButtonVariant | true;
    }>;
    actions: PropType<(NotificationAction | "-")[]>;
    delay: {
        type: NumberConstructor;
        default: number;
    };
    type: {
        type: PropType<NotificationType>;
        default: string;
    };
    toast: {
        type: BooleanConstructor;
        default: boolean;
    };
    persistent: {
        type: BooleanConstructor;
        default: boolean;
    };
}>> & {
    onDismiss?: ((event: unknown) => any) | undefined;
    onAction?: ((action: NotificationAction) => any) | undefined;
}, {
    type: NotificationType;
    ouiaId: string;
    ouiaSafe: boolean;
    toast: boolean;
    delay: number;
    persistent: boolean;
}>;
export default _default;
